searchData={"items":[{"type":"module","title":"BraveEx","doc":"A client library for interacting with the Brave Search API.","ref":"BraveEx.html"},{"type":"function","title":"BraveEx.get_query_suggestion/2","doc":"","ref":"BraveEx.html#get_query_suggestion/2"},{"type":"function","title":"BraveEx.image_search/2","doc":"","ref":"BraveEx.html#image_search/2"},{"type":"function","title":"BraveEx.news_search/2","doc":"","ref":"BraveEx.html#news_search/2"},{"type":"function","title":"BraveEx.spellcheck/2","doc":"","ref":"BraveEx.html#spellcheck/2"},{"type":"function","title":"BraveEx.video_search/2","doc":"","ref":"BraveEx.html#video_search/2"},{"type":"function","title":"BraveEx.web_search/2","doc":"Does a Web search as default with Brave api search.","ref":"BraveEx.html#web_search/2"},{"type":"function","title":"Parameters - BraveEx.web_search/2","doc":"- q: The query being passed\n      - Default:  None\n      - Required: True\n  - opts: Keyword list of options\n  \n      - `:base_url` - The base url for the API, this can be changed for versions, or if needed in the future.\n          - Default: https://api.search.brave.com/res/v1\n          - Required: true\n\n      - `:timeout`  - Request timeout in milliseconds\n          - Default: 10000\n          - Required: false\n\n      - `:api_key`  - The API key for your usage.\n          - Default: Default is pulled from ENV for BRAVE_API_KEY or you can set the :app below to use in config\n          - Required: true\n\n      - `:app` - The application name to use when fetching the API key from config\n          - Default: :brave_ex\n          - Required: false\n\n      - `:country`  - The search query country, where the results come from. The country string is limited to 2 character country codes of supported countries.\n          - Default:  US\n          - Required: false\n\n      - `:search_lang` - The search language preference.\n          - Default:  en\n          - Required: false\n\n      - `:ui_lang`  - User interface language preferred in response. Usually of the format ‘ - ’.\n          - Default:  en-US\n          - Required: false\n\n      - `:count` - The number of search results returned in response. The maximum is 20. The actual number delivered may be less than requested. Combine this parameter with offset to paginate search results.\n          - Default:  20\n          - Required: false\n\n      - `:offset`  - The zero based offset that indicates number of search results per page (count) to skip before returning the result. The maximum is 9. The actual number delivered may be less than requested based on the query. In order to paginate results use this parameter together with count. For example, if your user interface displays 20 search results per page, set count to 20 and offset to 0 to show the first page of results. To get subsequent pages, increment offset by 1 (e.g. 0, 1, 2). The results may overlap across multiple pages.\n          - Default:  0\n          - Required: false\n\n      - `:safesearch`  - Filters search results for adult content. Options are off, moderate, and IgnoreFileStrict\n          - Default:  moderate\n          - Required: false\n\n      - `:freshness` - Filters search results by when they were discovered. pd will return last 24 hours, pw will return the last 7 days, pm will return the last 31 days, py will return the last 365 days timeframe is also supported by specifying the date range e.g. 2022-04-01to2022-07-30 . \n          - Default:  no filtering\n          - Required: false\n\n\n      - `:text_decorations` - Whether display strings (e.g. result snippets) should include decoration markers (e.g. highlighting characters).\n          - Default: 1\n          - Required: false\n\n      - `:spellcheck` - Whether to spellcheck provided query. If the spellchecker is enabled, the modified query is always used for search. The modified query can be found in altered key from the query response model.\n          - Default:  1\n          - Required: false\n      \n      - `:result_filter` - A comma delimited string of result types to include in the search response. Not specifying this parameter will return back all result types in search response where data is available and a plan with the corresponding option is subscribed. The response always includes query and type to identify any query modifications and response type respectively. Available result filter values are: discussions, faq, infobox, news, query, summarizer, videos, web, locations\n          - Default:  No default\n          - Required: false\n      \n      - `:goggles`  - Goggles act as a custom re-ranking on top of Brave’s search index. The parameter supports both a url where the Goggle is hosted or the definition of the goggle.\n          - Default:  No default\n          - Required: false\n      \n      - `:units`  - The measurement units. If not provided, units are derived from search country. Possible values are metric and imperial. \n          - Default:  No default\n          - Required: false\n      \n      - `:extra_snippets`  - A snippet is an excerpt from a page you get as a result of the query, and extra_snippets allow you to get up to 5 additional, alternative excerpts. This is only available in the following tiers Free AI, Base AI, Pro AI, Pro Data, and custom plans. \n          - Default:  No default\n          - Required: false\n\n      - `:summary`  - This parameter enables summary key generation in web search results. This is required for summarizer to be enabled.\n          - Default:  No default\n          - Required: false","ref":"BraveEx.html#web_search/2-parameters"},{"type":"extras","title":"BraveEx","doc":"# BraveEx\n\n**BraveEx** is an Elixir client library for interacting with the [Brave Search API](https://api.search.brave.com). It provides a simple and consistent interface to perform web, image, video, news searches, fetch query suggestions, and perform spellchecks—all using a unified API.","ref":"readme.html"},{"type":"extras","title":"Features - BraveEx","doc":"- **Web Search:** Quickly perform standard web searches.\n- **Image Search:** Retrieve image search results.\n- **Video Search:** Get video search results.\n- **News Search:** Access the latest news results.\n- **Query Suggestions & Spellcheck:** Enhance your search experience with suggestions and spellchecking.","ref":"readme.html#features"},{"type":"extras","title":"Installation - BraveEx","doc":"Add `brave_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:brave_ex, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThen, fetch the dependencies by running:\n\n```sh\nmix deps.get\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - BraveEx","doc":"BraveEx requires an API key for authenticating with the Brave Search API. The API key is determined via the following priority:\n\n1. Passed in explicitly as an option (`:api_key`).\n2. Pulled from the environment variable `BRAVE_API_KEY`.\n3. Retrieved from your application configuration (default app key is `:brave_ex`).\n\nMake sure your API key is set in one of these ways before using the library.","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - BraveEx","doc":"All search functions accept a query string and an optional keyword list of parameters to customize the search request.","ref":"readme.html#usage"},{"type":"extras","title":"Web Search Example - BraveEx","doc":"```elixir\niex> BraveEx.web_search(\"Elixir programming\")\n```","ref":"readme.html#web-search-example"},{"type":"extras","title":"Other Search Functions - BraveEx","doc":"- **Image Search**\n\n  ```elixir\n  iex> BraveEx.image_search(\"Elixir logo\")\n  ```\n\n- **Video Search**\n\n  ```elixir\n  iex> BraveEx.video_search(\"Elixir tutorial\")\n  ```\n\n- **News Search**\n\n  ```elixir\n  iex> BraveEx.news_search(\"Elixir release\")\n  ```\n\n- **Query Suggestions**\n\n  ```elixir\n  iex> BraveEx.get_query_suggestion(\"Elixir\")\n  ```\n\n- **Spellcheck**\n\n  ```elixir\n  iex> BraveEx.spellcheck(\"Elixr\")\n  ```","ref":"readme.html#other-search-functions"},{"type":"extras","title":"Options - BraveEx","doc":"Each search function accepts an optional keyword list that lets you override default values and customize your request. Some of the common options include:\n\n- **`:base_url`**  \n  The base URL for the Brave API.  \n  _Default:_ `https://api.search.brave.com/res/v1`\n\n- **`:timeout`**  \n  Request timeout in milliseconds.  \n  _Default:_ `10_000`\n\n- **`:api_key`**  \n  Your Brave API key. If not provided, it will be fetched from the environment or config.\n\n- **`:app`**  \n  The application name used when fetching the API key from configuration.  \n  _Default:_ `:brave_ex`\n\n- **`:country`**  \n  The country code for the search.  \n  _Default:_ `\"US\"`\n\n- **`:search_lang`**  \n  The search language preference.  \n  _Default:_ `\"en\"`\n\n- **`:ui_lang`**  \n  The user interface language for the response (e.g., `\"en-US\"`).  \n  _Default:_ `\"en-US\"`\n\n- **`:count`**  \n  The number of search results returned.  \n  _Default:_ `20`\n\n- **`:offset`**  \n  Pagination offset for search results.  \n  _Default:_ `0`\n\n- Other options include `:safesearch`, `:freshness`, `:text_decorations`, `:spellcheck`, `:result_filter`, `:goggles`, `:units`, `:extra_snippets`, and `:summary`.\n\nFor full details, please refer to the function documentation inside the module.","ref":"readme.html#options"},{"type":"extras","title":"Contributing - BraveEx","doc":"Contributions are welcome! If you’d like to help improve BraveEx, feel free to fork the repository and submit pull requests. For any major changes, please open an issue first to discuss what you would like to change.","ref":"readme.html#contributing"},{"type":"extras","title":"License - BraveEx","doc":"BraveEx is released under the BSD-3-Clause License.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}